# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
import typing_extensions
import typing_extensions
from .evaluator_response_spec import EvaluatorResponseSpecParams
import typing
from .environment_response import EnvironmentResponseParams
import datetime as dt
from ..types.user_response import UserResponse
from .input_response import InputResponseParams
from .evaluator_aggregate import EvaluatorAggregateParams
import typing

if typing.TYPE_CHECKING:
    from .monitoring_evaluator_response import MonitoringEvaluatorResponseParams


class EvaluatorResponseParams(typing_extensions.TypedDict):
    """
    Version of the Evaluator used to provide judgments.
    """

    path: str
    """
    Path of the Evaluator including the Evaluator name, which is used as a unique identifier.
    """

    id: str
    """
    Unique identifier for the Evaluator.
    """

    directory_id: typing_extensions.NotRequired[str]
    """
    ID of the directory that the file is in on Humanloop.
    """

    version_name: typing_extensions.NotRequired[str]
    """
    Unique name for the Evaluator version. Version names must be unique for a given Evaluator.
    """

    version_description: typing_extensions.NotRequired[str]
    """
    Description of the version, e.g., the changes made in this version.
    """

    spec: EvaluatorResponseSpecParams
    name: str
    """
    Name of the Evaluator, which is used as a unique identifier.
    """

    description: typing_extensions.NotRequired[str]
    """
    Description of the Evaluator.
    """

    readme: typing_extensions.NotRequired[str]
    """
    Long description of the file.
    """

    tags: typing_extensions.NotRequired[typing.Sequence[str]]
    """
    List of tags associated with the file.
    """

    version_id: str
    """
    Unique identifier for the specific Evaluator Version. If no query params provided, the default deployed Evaluator Version is returned.
    """

    type: typing_extensions.NotRequired[typing.Literal["evaluator"]]
    environments: typing_extensions.NotRequired[typing.Sequence[EnvironmentResponseParams]]
    """
    The list of environments the Evaluator Version is deployed to.
    """

    created_at: dt.datetime
    updated_at: dt.datetime
    created_by: typing_extensions.NotRequired[UserResponse]
    """
    The user who created the Evaluator.
    """

    last_used_at: dt.datetime
    version_logs_count: int
    """
    The number of logs that have been generated for this Evaluator Version
    """

    total_logs_count: int
    """
    The number of logs that have been generated across all Evaluator Versions
    """

    inputs: typing.Sequence[InputResponseParams]
    """
    Inputs associated to the Evaluator. Inputs correspond to any of the variables used within the Evaluator template.
    """

    evaluators: typing_extensions.NotRequired[typing.Sequence["MonitoringEvaluatorResponseParams"]]
    """
    Evaluators that have been attached to this Evaluator that are used for monitoring logs.
    """

    evaluator_aggregates: typing_extensions.NotRequired[typing.Sequence[EvaluatorAggregateParams]]
    """
    Aggregation of Evaluator results for the Evaluator Version.
    """

    attributes: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    Additional fields to describe the Evaluator. Helpful to separate Evaluator versions from each other with details on how they were created or used.
    """
