# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluator_response import EvaluatorResponse
from .flow_response import FlowResponse
from .monitoring_evaluator_response import MonitoringEvaluatorResponse
from .prompt_response import PromptResponse
from .tool_response import ToolResponse
from .version_deployment_response import VersionDeploymentResponse
from .version_id_response import VersionIdResponse
import pydantic
import typing
from .evaluation_evaluator_response import EvaluationEvaluatorResponse
import datetime as dt
from .user_response import UserResponse
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class EvaluationResponse(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    Unique identifier for the Evaluation. Starts with `evr`.
    """

    runs_count: int = pydantic.Field()
    """
    The total number of Runs in the Evaluation.
    """

    evaluators: typing.List[EvaluationEvaluatorResponse] = pydantic.Field()
    """
    The Evaluator Versions used to evaluate.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the Evaluation to help identify it. Must be unique among Evaluations associated with File.
    """

    file_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier for the File associated with the Evaluation.
    """

    created_at: dt.datetime
    created_by: typing.Optional[UserResponse] = None
    updated_at: dt.datetime
    url: typing.Optional[str] = pydantic.Field(default=None)
    """
    URL to view the Evaluation on the Humanloop.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
